(function () {
    'use strict';

    var cssBasketButtonClass = function (options) {
        this.init(options);
    };

    cssBasketButtonClass.NAME = 'cssBasketButton';
    cssBasketButtonClass.VERSION = '1.0.0';
    cssBasketButtonClass.DEFAULTS = { 
  			showDebug : false,
      	elementId				: '#quantity',
      	preisbox					:	'.product-offer .price',
      	actualprice			: '#css-preisUpdate',
      	decimal						: 2,
      	preisDecimal		: 2,
      	locale							: "de-DE",
      	unit									: "Stk.",
      	currency						:	"&euro;",
      	subButton				: "#css-minus",
      	addButton				: "#css-plus",
      	checkKeys				:	true,
      	staffel							: 0,
      	teilbar							: 'N',
      	priceSelector: ".product-offer .price_wrapper .price",
      	maxbestellmenge	: 99999999,
      	mindestbestellmenge	: 0,
      	abnahmeintervall	:0
    };
    
    cssBasketButtonClass.prototype = {

        constructor: cssBasketButtonClass,

        init: function (options) {
        		this.settings = $.extend({}, cssBasketButtonClass.DEFAULTS, options);
            var that = this;
            that.debug("Starte " + cssBasketButtonClass.NAME  + " Version " + cssBasketButtonClass.VERSION);
        },

        register: function(options) {
        	var that=this;
  				that.debug("register Options");
        	that.	cleanAll();
        	that.registerAddButton();
        	that.registerSubButton();
        	that.registerInputField();
        	that.registerEvents();
        	that.updatePreis();
  				if(that.settings.elementId!='') {
  					return;
  					that.settings.elementId = $(this).find(that.settings.elementId);
  					that.debug("arbeite innerhalb eines containers");
  				} else that.settings.elementId = this;
    },
        
        debug: function(s) {
        	if(this.settings.showDebug) {
        		console.log(s);
        	}
        },

        updateSettings:	function() {
        	if($("#css-preisUpdate").length==0) return false;
        	this.settings.currency				=	$("#css-preisUpdate").data("currency");
        	this.settings.staffel = JSON.parse(JSON.stringify($("#css-preisUpdate").data("staffel")));
        	this.settings.maxbestellmenge = $("#css-preisUpdate").data("maxbestellmenge");
        	this.settings.mindestbestellmenge = $("#css-preisUpdate").data("mindestbestellmenge");
        	this.settings.abnahmeintervall =  $("#css-preisUpdate").data("abnahmeintervall");
        	this.settings.teilbar =  $("#css-preisUpdate").data("teilbar");
        	this.settings.unit=  $("#css-preisUpdate").data("einheit");
        	this.settings.decimal=  $("#css-preisUpdate").data("decimal");
        	if(this.settings.teilbar=='Y' && this.settings.abnahmeintervall<=0) this.settings.abnahmeintervall=0.1;
 	     }, 

 	    cleanAll: function() {
 	    	$(this.settings.subButton).off();
 	    	$(this.settings.addButton).off();
 	    	$(this.settings.elementId).off();
 	    } , 

			cssUpdateBasketButtonPlugin: function (modalArticleDialogCounter) {
				var that=this;
				if($("#modal-article-dialog #add-to-cart").length==0 && modalArticleDialogCounter<10) {
					modalArticleDialogCounter++;
					setTimeout(function(){
//						that.debug("schaue nach modal-article-dialog");
						that.cssUpdateBasketButtonPlugin(modalArticleDialogCounter)
				  },modalArticleDialogCounter*100);
				} else {
//					that.debug("gefunden modal-article-dialog");
					that.updatePreis();
				}
			},

			updatePreis: function() {
				var that = this;
				if(	$(that.settings.elementId)=='NaN' || $(that.settings.elementId).length==0) return;
				this.updateSettings();
				var settings = this.settings;
				var alert ="";

				
				this.output(	$(settings.elementId).val(),	this.roundDecimal(this.getPriceValue($(settings.elementId).val(),settings.staffel),settings.preisDecimal),this.roundDecimal($(settings.elementId).val() * this.getPriceValue($(settings.elementId).val(),settings.staffel),settings.preisDecimal),alert);
			},
    
 	    registerEvents: function() {
 	    	var that = this;
				$(document).on("evo:changed.article.price",function(data,price) { 
					that.debug(data); 
					that.debug(price.price); 
					$("meta[itemprop='price']").attr("content",price.price);
					$("#css-preisUpdate").attr("data-preis",price.price).data("preis",price.price);
					that.updatePreis();
					$(document).trigger("cssUpdatePreis");
				});

				
				$(document).on('evo:priceChanged', function() {
					that.debug("content priceChanged");
					that.updatePreis();
				});

				$(document).on('evo:changed', function() {
					that.debug("content Changed");
					that.updatePreis();
				});

				$(document).on('evo:contentLoaded', function() {
					that.debug("content loaded");
					that.updatePreis();
			  });

				$("body").on('shown.bs.modal', '#modal-article-dialog', function () {
					that.debug("modal-article-dialog");
					that.cssUpdateBasketButtonPlugin(1);
				});

				$("body").on("cssUpdateMaxbestellmenge",function(el,anzahl) {
					var settings = that.settings; 
					if(typeof anzahl !== 'undefined') {
						settings.maxbestellmenge = anzahl;
						$("#css-preisUpdate").attr("data-maxbestellmenge",anzahl).data("maxbestellmenge",anzahl);
						that.updatePreis();
					}
				});
				
				$("body").on("cssUpdatePreis",function(el,preis) {
					if(typeof preis !== 'undefined') {
						$("#css-preisUpdate").attr("data-preis",preis).data("preis",preis);
						that.updatePreis();
					}
				});				
 	    	
 	    },
 	    
 	    registerInputField: function() {
 	    	var that = this;
 	    	$("body").on("change input", that.settings.elementId, function(e) {

					var settings = that.settings; 
					that.debug("input log " + $(this).val());
					var _quantity = $(this).val().replace(/,/,".");
					var alert = '';
					
					if(_quantity > settings.maxbestellmenge) {
						that.debug("quantity = " +   quantity + " /  max = " + settings.maxbestellmenge)
						_quantity = settings.maxbestellmenge;
						$(settings.elementId).val(_quantity);
					}

					if(Number(_quantity) != Number(that.cleanQuantity(_quantity,settings.abnahmeintervall))) {
//						console.log(" hier stimmt was nicht: _quantity = " + _quantity + " clean = "  +Number(that.cleanQuantity(_quantity,settings.abnahmeintervall)))
						_quantity = Number(that.cleanQuantity(_quantity,settings.abnahmeintervall));
						alert = "interval-warning";
					}

					
					if(_quantity < settings.abnahmeintervall || _quantity < settings.mindestbestellmenge) {
						that.debug("hier stimmt was nicht: quantity = " +_quantity + " / abnahmeinterval = " +settings.abnahmeintervall + " / Mindestbestellmenge = " + settings.mindestbestellmenge);
//						_quantity = (abnahmeintervall) ? abnahmeintervall : 1;
						if(_quantity < settings.mindestbestellmenge ) {
							alert = "interval-warning";
						}
					}
					that.debug("berechneter quantitywert " + _quantity);
					that.debug("berechneter abnahmeintervallwert " + settings.abnahmeintervall);

					
					if(alert) {
						$(settings.elementId).closest("form").find("button[name='inWarenkorb']").attr("disabled",true);
					} else {
						$(settings.elementId).closest("form").find("button[name='inWarenkorb']").attr("disabled",false);
					}
					
					$(settings.actualprice).html(_quantity + "*" + that.getPriceValue(_quantity,settings.staffel));

					that.output(that.cleanQuantity(_quantity,settings.abnahmeintervall,''),that.roundDecimal(that.getPriceValue(_quantity,settings.staffel),settings.preisDecimal),that.roundDecimal(_quantity * that.getPriceValue(_quantity,settings.staffel),settings.preisDecimal),alert);
				});
				
				$("body").on("keyup blur keydown", that.settings.elementId, function(e) {
					var settings = that.settings;
					that.debug(e);
					if($(this).hasClass("update")) {
//						return false;
					}
					if(e.type=='keydown') {
						that.debug("keycode " + e.keyCode);
						switch(e.keyCode) {
							case 37:
							case 39:
							case 46:
							case 8:
								return true;

							case 13: return true;

							case 188:
							case 190: if(settings.teilbar=='Y') {
								return true;
							}
							default: 
								that.debug(e);
								if(e.key == 0 || Number(e.key)>0 && Number(e.key)<=9) { 
									that.debug("keycode " + e.keyCode);
									break;
								}
								if(e.keyCode < 48 || e.keyCode > 57) { 
									that.debug("keycode " + e.keyCode);
									return false;
								}
								if($(this).val()<20) return true;
						}
					}

					if(e.type=="keyup") {
						that.debug("keyup " + e.keyCode);
						if(settings.checkKeys=== false)	return false;
						if(e.keyCode==13) {
//							that.cleanQuantity($(this).val(),abnahmeintervall,e.type);
							return false;
						}
						
						if($(this).val().toLocaleString(settings.locale).length <= settings.mindestbestellmenge.toLocaleString(settings.locale).length) {
							that.debug("keine aktion");
							return false;
						}
					}
					
					$(this).addClass("update");
					if(e.type=='blur' || e.type=='focusout') {
						$(this).val(that.cleanQuantity($(this).val().replace(/,/,"."),settings.abnahmeintervall,e.type));
						that.cleanInputField();
					}
					$(this).removeClass("update");
					that.debug("ausgabe aktualisieren " + $(this).val());					
				});
				
 	    },
 	    
 	    cleanInputField: function() {
 	    	var that=this;
 	    	var settings = that.settings;
				if(settings.teilbar=='Y') {
					var tempVal = $(settings.elementId).val().replace(/\,/,".")
					tempVal = "" + Number(tempVal).toFixed(settings.decimal)
					tempVal.replace(/\./,",");
					$(settings.elementId).val(tempVal);
				}	else {
					$(settings.elementId).val(parseInt($(settings.elementId).val()));
				}					
 	    },
 	    
 	    registerSubButton: function(settings) {
 	    	var that = this;
				$("body").on("click",that.settings.subButton, function(e) {
					var settings = that.settings; 
					e.stopPropagation();
					var step = (settings.abnahmeintervall>0) ? settings.abnahmeintervall : 1;
					$(settings.elementId).focus();
					
					
					that.debug("Step ->" + Math.ceil(step));
					that.debug("test ->" + Number(Number($(settings.elementId).val()) + Number(step)));
					that.debug(settings.elementId);
					
					var _quantity = $(settings.elementId).val().replace(/,/,".");
					_quantity = Number(Number(_quantity) - Number(step));

					if(Number(that.cleanQuantity(_quantity,settings.abnahmeintervall,'')) != Number(that.round(_quantity,3))) {
						_quantity = _quantity + settings.abnahmeintervall;
					}

					
					that.debug("Menge ceil = " + Math.ceil(_quantity) + " Menge = " + Number(_quantity));

					if(Math.ceil(_quantity) > Number(_quantity)) {
						_quantity = _quantity.toFixed(settings.decimal);
					} else {
						_quantity = Math.ceil(_quantity);
					} 

					if(_quantity >= settings.mindestbestellmenge) {
						$(settings.elementId).val(_quantity);
					}
					
					if(that.cleanQuantity(_quantity,settings.abnahmeintervall,'') != that.round(_quantity,3)) {
						$(settings.elementId).val(that.cleanQuantity(_quantity,settings.abnahmeintervall,''));
					}


					$(settings.elementId).blur();
					$(settings.elementId).trigger("input");
					return false;
				});
 	    },
 	    
 	    registerAddButton: function() {
 	    	var that = this;
 	    	$("body").on("click",that.settings.addButton, function(e) {
					var settings = that.settings; 
					e.stopPropagation();
					var step = (settings.abnahmeintervall>0) ? Number(settings.abnahmeintervall) : 1;
					$(settings.elementId).focus();
					
					that.debug("Step ->" + Math.ceil(step));
					that.debug("test ->" + Number(Number($(settings.elementId).val()) + Number(step)));
					that.debug(settings.elementId);
					
					var _quantity = $(settings.elementId).val().replace(/,/,".");
					
					that.debug("Menge ceil = " + Math.ceil(_quantity) + " Menge = " + Number(_quantity));

					_quantity = Number(Number(_quantity) + Number(step));

					that.debug(" quantity = " + _quantity);

					if(Math.ceil(_quantity) > Number(_quantity)) {
						_quantity = _quantity.toFixed(settings.decimal);
					} else {
						_quantity = Math.ceil(_quantity);
					} 

					$(settings.elementId).val(_quantity);

					
					if(that.cleanQuantity(_quantity,settings.abnahmeintervall,'') != $(settings.elementId).val()) {
						$(settings.elementId).val(that.cleanQuantity(_quantity,settings.abnahmeintervall,''));
					}

					$(settings.elementId).blur();
					$(settings.elementId).trigger("input");
					return false;
				});
 	    },
 	    
			roundDecimal: function (number, decimalplaces ) {
				var settings = this.settings;
				var that = this;
			    if(decimalplaces > 0){
		        var multiply1 = Math.pow(10,(decimalplaces + 4));
		        var divide1 = Math.pow(10, decimalplaces);
		        var preis = Math.round( Math.round(number * multiply1)/10000 )/divide1 ;
		    }
	
	      preis = preis.toLocaleString(settings.locale, { minimumFractionDigits:decimalplaces, maximumFractionDigits:decimalplaces, useGrouping:false})
	      that.debug(preis);
		    return preis;
			},
  
			round: function(wert, dez) {
        wert = parseFloat(wert);
        if (!wert) return 0;
        dez = parseInt(dez);
        if (!dez) dez=0;

        var umrechnungsfaktor = Math.pow(10,dez);

        return Math.round(wert * umrechnungsfaktor) / umrechnungsfaktor;
			},
			
			cleanQuantity: function(quantity,abnahmeintervall,type) {
				var that = this;
				var settings = that.settings; 
				if(type=='keyup') return quantity;
				if(abnahmeintervall<=0) abnahmeintervall=1;
				if(quantity<=0) quantity=abnahmeintervall;
				quantity = Number(quantity).toFixed(settings.decimal);
				if(quantity > settings.maxbestellmenge) {
//					console.log("quantity = " +   quantity + " /  max = " + settings.maxbestellmenge)
					quantity = settings.maxbestellmenge;
				}

//				console.log("quantity = " + quantity + " / abnahmeintervall = " + abnahmeintervall + " / math floor = " + that.round(quantity / abnahmeintervall,settings.decimal) );
				quantity = Number( quantity);

				if(settings.teilbar!='Y') {
					quantity = quantity.toFixed(settings.decimal);
					var newQuantity = Math.floor(quantity / abnahmeintervall) * abnahmeintervall;
				} else {
					var newQuantity = Math.floor(that.round(quantity / abnahmeintervall,settings.decimal)) * abnahmeintervall;
					}

				that.debug("mein quantity " + newQuantity);
				
				if(this.settings.teilbar=='Y') {
					newQuantity = Number(newQuantity).toFixed(settings.decimal);
				} else {
					newQuantity = parseInt(newQuantity);
				}
				return Number(newQuantity);
			}, 	     

			getPriceValue: function (quantity,staffel) {
				var that = this;
				var preis=$("#css-preisUpdate").data("preis");
				if(staffel===null) {
					return $("#css-preisUpdate").data("preis");
				}
				that.debug("staffel - > ");
				that.debug(staffel);
				jQuery.each(staffel,function(key , value) {
					if(Number(key) <= Number(quantity)) preis = value;
					else return;
					that.debug(key + " > " + value + " - " + quantity + " > " +preis);
				});
				that.debug(preis);
				return preis;
			},

			output: function (anzahl,staffel,preis,alert) {
				var that = this;
				var settings = this.settings;
				if(typeof alert == 'undefined') var alert=''; 
				if(typeof anzahl == 'undefined' || anzahl == '')  anzahl="1";
				
				if(settings.teilbar=='Y') {
					anzahl ="" + Number(anzahl).toFixed(settings.decimal);
				} else {
					anzahl ="" + anzahl;
				}
				
				anzahl = anzahl.replace(/\./,",");
				var out = '<span class="' + alert + '"><span class="css-preisupdate-anzahl"> ' + anzahl + ' '
				+ '<span class="css-preisupdate-unit"> ' + settings.unit + ' </span></span>'
				+ '<span class="css-preisupdate-multiplikator"> * </span>'
				+ '<span class="css-preisupdate-staffel"> '	+ staffel + ' '
				+ '<span class="css-preisupdate-currency"> '	+ settings.currency + ' </span></span>'
				+ '<span class="css-preisupdate-ergebnis">  = </span>'
				+ '<span class="css-preisupdate-preis"> '	+ preis	+ ' '
				+ '<span class="css-preisupdate-currency"> ' + settings.currency + '</span></span></span>';
				that.debug(out);
				$(settings.actualprice).html(out);
				$(settings.priceSelector).html(preis + " " + settings.currency);
			},
        
   };

    $.cssBasketButton = function(options) {
    	$.cssBB = new cssBasketButtonClass(options);
    	$.cssBB.register();
    	return $.cssBB;
    };
})(jQuery);

$.cssBasketButton();
